-- binary.e demo of btype definitions and get_binary()

include get.e
include binary.e

-- btype definition
constant
 TopTen = startBinaryType()
,Score    = addField(1, uInt16)
,Name     = addField(1, ByteString(11))
,Date     = addField(1, ByteString(11))
	  endBinaryType()

constant
 FILENAME = {"CRUX","LOYD","OTRA","PUSH","SHUT","YAHT"}
,PROGRAM_NAMES = {"Crux","Loyd","Otra","Push Your Luck","Shut The Box","Yaht"}

sequence tmp, scores, filename
integer fn

for f = 1 to length(FILENAME) do
   clear_screen()
   filename = "ML" & FILENAME[f] & ".SCR"
   fn = open(filename, "rb")
   if fn = -1 then
      printf(2, "%s not found\n", {filename})
   else
      printf(2, "Top Ten Scores for %s\n", {PROGRAM_NAMES[f]})
      for i = 1 to 10 do
	 tmp = get_binary(fn, TopTen)
	 if tmp[1] = GET_SUCCESS then
	    scores = tmp[2]
	 else
	    exit
	 end if
	 
	 if scores[Score] then
	    -- we have a score, print it
	    printf(2, "%5d  %-10s  %-10s\n",
		      {scores[Score], scores[Name], scores[Date]})
	 else
	    -- no score, empty slot
	    puts(2, "\n")
	 end if
      end for
      close(fn)
   end if
   puts(2, "Press any key to continue . . .")
   if wait_key() then
      puts(2, "\n")
   end if
end for


